package de.accso.flexinale.api_in.rest;

import de.accso.flexinale.application.services.VorfuehrungUploadService;
import de.accso.flexinale.domain.model.Vorfuehrung;
import de.accso.flexinale.application.services.VorfuehrungService;
import de.accso.flexinale.shared_kernel.Identifiable;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@RestController
public class VorfuehrungRestController extends AbstractExcelRestController {

    @Autowired
    private VorfuehrungService vorfuehrungService;

    @Autowired
    private VorfuehrungUploadService vorfuehrungUploadService;

    @GetMapping(value = "/rest/vorfuehrungen", produces = "application/json")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    public List<Vorfuehrung> vorfuehrungen() {
        return vorfuehrungService.vorfuehrungen();
    }

    @GetMapping(value = "/rest/vorfuehrungen/{id}", produces = "application/json")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    public Vorfuehrung vorfuehrung(@PathVariable final String id) {
        Identifiable.Id vorfuehrungId = Identifiable.Id.of(id);
        Vorfuehrung vorfuehrung = vorfuehrungService.vorfuehrung(vorfuehrungId);
        if (vorfuehrung == null) {
            throw new RestResourceNotFoundException("no Vorfuehrung %s found.".formatted(id));
        }

        return vorfuehrung;
    }

    @PostMapping("/rest/vorfuehrungen")
    @PreAuthorize("hasRole('ROLE_ADMIN')")
    public ResponseEntity<RestResponseMessage> uploadVorfuehrungen(@RequestParam("file") final MultipartFile file) {
        RestUploadResult restUploadResult = uploadViaRestCall(vorfuehrungUploadService, file);
        return ResponseEntity.status(restUploadResult.status())
                .body(new RestResponseMessage(restUploadResult.message()));
    }
}
